import { FaceMatcher } from "@vladmandic/face-api";
import { IRoom } from "./config";
import { Rtsp } from "rtsp-stream/lib";

export interface ILabelState {
  label: string;
  detected: boolean;
}

export type IRoomState = { [roomName: string]: Array<ILabelState> };

export class LocationMonitor {
  private _state: IRoomState = {};

  private _streams: Array<Rtsp> = [];

  constructor(private rooms: Array<IRoom>, private matcher: FaceMatcher) {
    //Initialize state
    for (const room of rooms) {
      this._streams.push(
        ...room.rtspConnectionStrings.map(
          (e) => new Rtsp(e, { rate: 0.5, image: true })
        )
      );

      this._state[room.name] = matcher.labeledDescriptors.map((e) => {
        return { label: e.label, detected: false };
      });
    }
  }

  public get state(): IRoomState {
    return this._state;
  }

  private async startStreams() {}

  private async stopStreams() {}
}
